git-mergetool--lib.sh 6.02 KB
Newer Older
1
#!/bin/sh
2 3 4 5 6 7 8 9 10 11
# git-mergetool--lib is a library for common merge tool functions
diff_mode() {
	test "$TOOL_MODE" = diff
}

merge_mode() {
	test "$TOOL_MODE" = merge
}

translate_merge_tool_path () {
12
	echo "$1"
13 14 15
}

check_unchanged () {
16 17
	if test "$MERGED" -nt "$BACKUP"
	then
18 19
		status=0
	else
20 21
		while true
		do
22 23
			echo "$MERGED seems unchanged."
			printf "Was the merge successful? [y/n] "
24
			read answer || return 1
25 26 27 28 29 30 31 32
			case "$answer" in
			y*|Y*) status=0; break ;;
			n*|N*) status=1; break ;;
			esac
		done
	fi
}

33 34 35 36 37 38 39 40 41
valid_tool_config () {
	if test -n "$(get_merge_tool_cmd "$1")"
	then
		return 0
	else
		return 1
	fi
}

42
valid_tool () {
43 44 45 46
	setup_tool "$1" || valid_tool_config "$1"
}

setup_tool () {
47
	case "$1" in
48 49
	vim*|gvim*)
		tool=vim
50 51
		;;
	*)
52
		tool="$1"
53 54
		;;
	esac
55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76
	mergetools="$(git --exec-path)/mergetools"

	# Load the default definitions
	. "$mergetools/defaults"
	if ! test -f "$mergetools/$tool"
	then
		return 1
	fi

	# Load the redefined functions
	. "$mergetools/$tool"

	if merge_mode && ! can_merge
	then
		echo "error: '$tool' can not be used to resolve merges" >&2
		exit 1
	elif diff_mode && ! can_diff
	then
		echo "error: '$tool' can only be used to resolve merges" >&2
		exit 1
	fi
	return 0
77 78 79
}

get_merge_tool_cmd () {
80
	# Prints the custom command for a merge tool
81
	merge_tool="$1"
82 83
	if diff_mode
	then
84
		echo "$(git config difftool.$merge_tool.cmd ||
85
			git config mergetool.$merge_tool.cmd)"
86 87 88
	else
		echo "$(git config mergetool.$merge_tool.cmd)"
	fi
89 90
}

91
# Entry point for running tools
92
run_merge_tool () {
93 94 95 96 97
	# If GIT_PREFIX is empty then we cannot use it in tools
	# that expect to be able to chdir() to its value.
	GIT_PREFIX=${GIT_PREFIX:-.}
	export GIT_PREFIX

98
	merge_tool_path="$(get_merge_tool_path "$1")" || exit
99 100 101
	base_present="$2"
	status=0

102 103 104 105 106
	# Bring tool-specific functions into scope
	setup_tool "$1"

	if merge_mode
	then
107
		run_merge_cmd "$1"
108
	else
109
		run_diff_cmd "$1"
110
	fi
111 112 113
	return $status
}

114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149
# Run a either a configured or built-in diff tool
run_diff_cmd () {
	merge_tool_cmd="$(get_merge_tool_cmd "$1")"
	if test -n "$merge_tool_cmd"
	then
		( eval $merge_tool_cmd )
		status=$?
		return $status
	else
		diff_cmd "$1"
	fi
}

# Run a either a configured or built-in merge tool
run_merge_cmd () {
	merge_tool_cmd="$(get_merge_tool_cmd "$1")"
	if test -n "$merge_tool_cmd"
	then
		trust_exit_code="$(git config --bool \
			mergetool."$1".trustExitCode || echo false)"
		if test "$trust_exit_code" = "false"
		then
			touch "$BACKUP"
			( eval $merge_tool_cmd )
			status=$?
			check_unchanged
		else
			( eval $merge_tool_cmd )
			status=$?
		fi
		return $status
	else
		merge_cmd "$1"
	fi
}

150
list_merge_tool_candidates () {
151 152
	if merge_mode
	then
153 154 155 156
		tools="tortoisemerge"
	else
		tools="kompare"
	fi
157 158 159 160
	if test -n "$DISPLAY"
	then
		if test -n "$GNOME_DESKTOP_SESSION_ID"
		then
161 162 163 164
			tools="meld opendiff kdiff3 tkdiff xxdiff $tools"
		else
			tools="opendiff kdiff3 tkdiff xxdiff meld $tools"
		fi
165
		tools="$tools gvimdiff diffuse ecmerge p4merge araxis bc3 codecompare"
166
	fi
167 168
	case "${VISUAL:-$EDITOR}" in
	*vim*)
169
		tools="$tools vimdiff emerge"
170 171
		;;
	*)
172
		tools="$tools emerge vimdiff"
173 174
		;;
	esac
175 176
}

177 178 179
show_tool_help () {
	unavailable= available= LF='
'
180 181 182

	scriptlets="$(git --exec-path)"/mergetools
	for i in "$scriptlets"/*
183
	do
184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199
		. "$scriptlets"/defaults
		. "$i"

		tool="$(basename "$i")"
		if test "$tool" = "defaults"
		then
			continue
		elif merge_mode && ! can_merge
		then
			continue
		elif diff_mode && ! can_diff
		then
			continue
		fi

		merge_tool_path=$(translate_merge_tool_path "$tool")
200 201
		if type "$merge_tool_path" >/dev/null 2>&1
		then
202
			available="$available$tool$LF"
203
		else
204
			unavailable="$unavailable$tool$LF"
205 206
		fi
	done
207 208

	cmd_name=${TOOL_MODE}tool
209 210
	if test -n "$available"
	then
211
		echo "'git $cmd_name --tool=<tool>' may be set to one of the following:"
212 213
		echo "$available" | sort | sed -e 's/^/	/'
	else
214
		echo "No suitable tool for 'git $cmd_name --tool=<tool>' found."
215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230
	fi
	if test -n "$unavailable"
	then
		echo
		echo 'The following tools are valid, but not currently available:'
		echo "$unavailable" | sort | sed -e 's/^/	/'
	fi
	if test -n "$unavailable$available"
	then
		echo
		echo "Some of the tools listed above only work in a windowed"
		echo "environment. If run in a terminal-only session, they will fail."
	fi
	exit 0
}

231 232
guess_merge_tool () {
	list_merge_tool_candidates
233 234 235 236 237 238
	echo >&2 "merge tool candidates: $tools"

	# Loop over each candidate and stop when a valid merge tool is found.
	for i in $tools
	do
		merge_tool_path="$(translate_merge_tool_path "$i")"
239 240
		if type "$merge_tool_path" >/dev/null 2>&1
		then
241 242
			echo "$i"
			return 0
243 244 245
		fi
	done

246 247
	echo >&2 "No known merge resolution program available."
	return 1
248 249 250 251 252
}

get_configured_merge_tool () {
	# Diff mode first tries diff.tool and falls back to merge.tool.
	# Merge mode only checks merge.tool
253 254
	if diff_mode
	then
255 256 257
		merge_tool=$(git config diff.tool || git config merge.tool)
	else
		merge_tool=$(git config merge.tool)
258
	fi
259 260
	if test -n "$merge_tool" && ! valid_tool "$merge_tool"
	then
261 262 263 264
		echo >&2 "git config option $TOOL_MODE.tool set to unknown tool: $merge_tool"
		echo >&2 "Resetting to default..."
		return 1
	fi
265
	echo "$merge_tool"
266 267 268 269
}

get_merge_tool_path () {
	# A merge tool has been set, so verify that it's valid.
270
	merge_tool="$1"
271 272
	if ! valid_tool "$merge_tool"
	then
273 274 275
		echo >&2 "Unknown merge tool $merge_tool"
		exit 1
	fi
276 277
	if diff_mode
	then
278
		merge_tool_path=$(git config difftool."$merge_tool".path ||
279
				  git config mergetool."$merge_tool".path)
280 281
	else
		merge_tool_path=$(git config mergetool."$merge_tool".path)
282
	fi
283 284
	if test -z "$merge_tool_path"
	then
285
		merge_tool_path="$(translate_merge_tool_path "$merge_tool")"
286
	fi
287
	if test -z "$(get_merge_tool_cmd "$merge_tool")" &&
288 289
		! type "$merge_tool_path" >/dev/null 2>&1
	then
290
		echo >&2 "The $TOOL_MODE tool $merge_tool is not available as"\
291
			 "'$merge_tool_path'"
292 293 294 295 296 297 298
		exit 1
	fi
	echo "$merge_tool_path"
}

get_merge_tool () {
	# Check if a merge tool has been configured
299
	merge_tool="$(get_configured_merge_tool)"
300
	# Try to guess an appropriate merge tool if no tool has been set.
301 302
	if test -z "$merge_tool"
	then
303
		merge_tool="$(guess_merge_tool)" || exit
304 305 306
	fi
	echo "$merge_tool"
}